package com.eactive.eai.common.bizkey;

import static org.junit.Assert.assertNotNull;
import static org.junit.Assert.assertTrue;

import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.domain.EntityScan;
import org.springframework.boot.test.autoconfigure.orm.jpa.DataJpaTest;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.data.jpa.repository.config.EnableJpaRepositories;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.jdbc.Sql;

import com.eactive.eai.data.CommonJPATestConfiguration;
import com.eactive.eai.data.jpa.BaseRepositoryImpl;

@DataJpaTest
@ContextConfiguration(classes = { CommonJPATestConfiguration.class })
@ComponentScan({ "com.eactive.eai.common.bizkey" })
@EnableJpaRepositories(repositoryBaseClass = BaseRepositoryImpl.class, basePackages = {
		"com.eactive.eai.common.bizkey" })
@EntityScan({ "com.eactive.eai.data.entity.onl.bizkey" })
@Sql({ "/com/eactive/eai/common/bizkey/init_tseaifr03.sql" })
class BizKeyDAOTest {
	@Autowired
	BizKeyDAO bizKeyDAO;

	@Test
	void getAllBizKeysTest() throws Exception {
		// given

		// when
		bizKeyDAO.getAllBizKeys();

		// then
		assertNotNull(bizKeyDAO.getAllBizKeys());
		assertTrue(bizKeyDAO.getAllBizKeys().size() > 0);
	}

	@Test
	void getBizKeyTest() throws Exception {
		// given
		String eaiSvcCd = "AC1B805Q01S2";
		String exrClsNm = "TR";

		// when
		bizKeyDAO.getBizKey(eaiSvcCd, exrClsNm);

		// then
		assertNotNull(bizKeyDAO.getBizKey(eaiSvcCd, exrClsNm));
		assertTrue(bizKeyDAO.getBizKey(eaiSvcCd, exrClsNm).size() > 0);
		assertTrue(bizKeyDAO.getBizKey(eaiSvcCd, exrClsNm).toString().length() > 0);
	}
}
